Scriptname AngrimApprenticeQuestScript extends Quest  

import Utility

SexLabFramework Property SexLab Auto
AngrimBeltQuestScript Property BeltQuest Auto
Quest Property AngrimBookQuest4 Auto
Quest Property DA14 Auto
Actor Property PlayerRef Auto
Actor Property AngrimRef Auto
Armor Property Reward Auto
Spell Property AngrimGiveMagicSpell Auto
Spell Property AngrimSuccubusCurse Auto
Spell Property AngrimRagingLustSpell Auto
Spell Property AngrimStealMagicSpell Auto
Spell Property AngrimStealHealthSpell Auto
Spell Property AngrimSummonEmissarySpell Auto
Spell Property AngrimGhostlyStateSpell Auto
Spell Property AngrimStealPowerSpell Auto
Spell Property AngrimStealWitsSpell Auto
Spell Property AngrimStealIllusionSpell Auto
Spell Property AngrimStealSoulSpell Auto
Spell Property AngrimGhostFadeSpell Auto
Spell Property AngrimVibrationSensing Auto
Spell Property AngrimOrdealAbility Auto
MagicEffect Property AngrimStealSoulFFSelf Auto
GlobalVariable Property AngrimSatiation Auto
GlobalVariable Property AngrimHasCuffs Auto
GlobalVariable Property AngrimHasCurse Auto
GlobalVariable Property AngrimPlayerGotElixir Auto
GlobalVariable Property AngrimPlayerIsSuccubus Auto
GlobalVariable Property AngrimSpellsTaught Auto
GlobalVariable Property AngrimSummonedEmissary Auto
GlobalVariable Property AngrimHasSSLV Auto
GlobalVariable Property AngrimHasDvCidhna Auto
ObjectReference Property CenterPoint Auto
ObjectReference Property WatchPoint Auto
ReferenceAlias Property LoveElixirAliasRef Auto
Book Property AngrimBookTheRealms Auto
Topic Property AngrimSummonMonologueTopic Auto
Topic Property AngrimSoulStealTopic Auto
Topic Property AngrimApprenticeMonologueGhost Auto
Faction Property CrimeFaction Auto
Idle Property Kneeling Auto
Idle Property Bound Auto
Idle Property HandsBound Auto
imageSpaceModifier Property VC01BlackoutIMod  Auto 
Keyword Property Zad_Lockable Auto
MiscObject Property Gold Auto
Message Property AngrimBoundOrdealMsg Auto
Faction Property AngrimEnthralledFaction Auto
Faction Property PlayerFaction Auto

Bool isOrdealDone = false

Event OnInit()
	Maintenance()
endEvent

Function Maintenance()
	Debug.Trace( "[Angrim] checking player race..." )
	if ( AngrimPlayerIsSuccubus.Value == 0 )
		;; Check if the player is an actual succubus, and apply the effects automatically:
		String raceName = Game.GetPlayer().GetRace().GetName()
		Debug.Trace( "[Angrim] player race is " + raceName )
		if ( StringUtil.Find( raceName, "Succubus" ) >= 0 )
			Debug.Trace( "[Angrim] Starting succubus effect" )
			AngrimPlayerIsSuccubus.Value = 1
			GiveCurse()
		endIf
		if ( StringUtil.Find( raceName, "Temptress" ) >= 0 )
			Debug.Trace( "[Angrim] Starting succubus effect" )
			AngrimPlayerIsSuccubus.Value = 1
			GiveCurse()
		endIf
	endIf
	if ( AngrimHasSSLV.Value == 0 && AngrimHasDvCidhna.Value == 0 )
		;; Check slavery mods installed, so we can modify some dialogue to fit:
		Debug.Trace( "[Angrim] checking if slavery mods are present..." )
		int idx = Game.GetModByName( "SimpleSlavery.esp" )
		int idx2 = Game.GetModByName( "Devious Cidhna.esp" )
		if ( idx != 255 )
			AngrimHasSSLV.Value = 1
		elseIf ( idx2 != 255 )
			AngrimHasDvCidhna.Value = 1
		endIf
	endIf
	AngrimEnthralledFaction.SetAlly( PlayerFaction )
	RegisterForModEvent( "AngrimBoundOrdealDone", "OrdealDone" )
endFunction

Function PerformAnim(int aType)
	Actor[] actors = new actor[2]
	Actor victim = None
	sslBaseAnimation[] anims
	actors[0] = PlayerRef
	actors[1] = AngrimRef
	
	if ( aType == 0 )
		anims = SexLab.GetAnimationsByTags( 2, Tags="Oral,FM", TagSuppress="Pillory" )
	elseIf ( aType == 1 )
		anims = SexLab.GetAnimationsByTags( 2,  Tags="Anal,FM", TagSuppress="Pillory" )
	elseIf ( aType == 2 )
		anims = SexLab.GetAnimationsByTags( 2,  Tags="Vaginal,FM", TagSuppress="Pillory" )
	elseIf ( aType == 3 )
		anims = SexLab.GetAnimationsByTags( 2,  Tags="Vaginal,FM,Aggressive", TagSuppress="Pillory" )
		victim = PlayerRef
	elseIf ( aType == 4 )
		anims = new sslBaseAnimation[4]
		anims[0] = SexLab.GetAnimationByName( "Arrok Cowgirl" )
		anims[1] = SexLab.GetAnimationByName( "Arrok Reverse Cowgirl" )
		anims[2] = SexLab.GetAnimationByName( "Arrok Standing Fuck" )
		anims[3] = SexLab.GetAnimationByName( "Arrok HugFuck" )
	elseIf ( aType == 5 )
		anims = new sslBaseAnimation[2]
		anims[0] = SexLab.GetAnimationByName( "Arrok Boobjob" )
		anims[1] = SexLab.GetAnimationByName( "Boobjob" )
	endIf

	if ( PlayerRef.HasMagicEffect( AngrimStealSoulFFSelf ) )
		RegisterForModEvent( "AnimationEnd", "TriggerSoulSteal" )
	elseIf ( AngrimHasCuffs.Value > 0 )
		RegisterForModEvent( "AnimationEnd", "TriggerReturnToIdle" )
	endIf

	SexLab.StartSex(actors, anims, victim, centerOn=CenterPoint, allowBed=false)
endFunction

Function ThrallAnim( Actor akActor, bool abRough = false )
	Actor[] actors = new actor[2]
	Actor victim = None
	sslBaseAnimation[] anims
	actors[0] = PlayerRef
	actors[1] = akActor
	
	if ( abRough )
		victim = PlayerRef
		anims = SexLab.GetAnimationsByTags( 2,  Tags="Vaginal,Aggressive", TagSuppress="Pillory" )
	else
		anims = SexLab.GetAnimationsByTags( 2,  Tags="Vaginal", TagSuppress="Pillory" )
	endIf

	SexLab.StartSex( actors, anims, victim, centerOn=PlayerRef, allowBed=true )
endFunction

Function ThrallAnimSolo( Actor akActor )
	Actor[] actors = new actor[1]
	Actor victim = None
	sslBaseAnimation[] anims
	actors[0] = akActor
	
	anims = SexLab.GetAnimationsByTags( 1, Tags="Solo" )

	SexLab.StartSex( actors, anims, victim, centerOn=akActor, allowBed=false )
endFunction

Event OrdealDone( string eventName, string argString, float argNum, form sender )
	if ( ! isOrdealDone )
		isOrdealDone = true
		AngrimBoundOrdealMsg.Show( )
		PlayerRef.AddSpell( AngrimVibrationSensing, false )
		PlayerRef.AddSpell( AngrimOrdealAbility, true )
	endIf
endEvent

Function CheckBonds()
	if ( PlayerRef.WornHasKeyword( Zad_Lockable ) )
		SetStage( 30 )
	endIf
endFunction

Function GiveMagic()
	AngrimGiveMagicSpell.Cast( AngrimRef, PlayerRef )
endFunction

Function GiveBindings()
	form[] gear = SexLab.StripActor( PlayerRef )
	BeltQuest.GagLock()
	PlayerRef.PlayIdle( Kneeling )
	BeltQuest.RestraintsLock()
	AngrimHasCuffs.Value = 1
	Game.ForceThirdPerson()
	Wait( 6.0 )
endFunction

Function RemoveBindings()
	BeltQuest.GagUnlock()
	BeltQuest.RestraintsUnlock()
	Debug.SendAnimationEvent( PlayerRef, "IdleForceDefaultState" )
	AngrimHasCuffs.Value = 0
endFunction

Function PayoffGuards()
	;; Arrange a surprise for the player's next visit to town...
	; CrimeFaction.SetCrimeGold(200)
endFunction

Function Slavery()
	if ( AngrimHasSSLV.Value > 0 )
		SendModEvent( "SSLV Entry" )
	elseIf ( AngrimHasDvCidhna.Value > 0 )
		SendModEvent( "DvCidhna_StartPirates" )
	endIf
endFunction

Function PickSpell()
	int pick
	int tries = 0
	int chosen = 0
	
	;; Pick one spell at random, keep trying if the player already knows it.
	while ( chosen == 0 && tries <= 20 )
		pick = RandomInt(0,2)
		if ( pick == 0 )
			if ( ! PlayerRef.HasSpell( AngrimStealHealthSpell ))
				PlayerRef.AddSpell( AngrimStealHealthSpell, true )
				AngrimSpellsTaught.Value = AngrimSpellsTaught.Value + 1
				chosen = 1
			endIf
		elseIf ( pick == 1 )
			if ( ! PlayerRef.HasSpell( AngrimStealWitsSpell ))
				PlayerRef.AddSpell( AngrimStealWitsSpell, true )
				AngrimSpellsTaught.Value = AngrimSpellsTaught.Value + 1
				chosen = 1
			endIf
		elseIf ( pick == 2 )
			if ( ! PlayerRef.HasSpell( AngrimStealIllusionSpell ))
				PlayerRef.AddSpell( AngrimStealIllusionSpell, true )
				AngrimSpellsTaught.Value = AngrimSpellsTaught.Value + 1
				chosen = 1
			endIf
		endIf
		tries = tries + 1
	endWhile
endFunction

Function GiveMagic2()
	PickSpell()
	if ( ! PlayerRef.HasSpell( AngrimSuccubusCurse ) )
		PlayerRef.AddSpell( AngrimRagingLustSpell, false )
		;; Start off with a 24 hour grace period (2 hours per interval):
		AngrimSatiation.Value = 22
	endIf
endFunction

Function GiveMagic3()
	PickSpell()
endFunction

Function LiftCurse()
	if ( ! PlayerRef.HasSpell( AngrimSuccubusCurse ) )
		PlayerRef.RemoveSpell( AngrimRagingLustSpell )
		AngrimHasCurse.Value = 0
	endIf
endFunction

Function GiveCurse()
	AngrimHasCurse.Value = 1
	if ( ! PlayerRef.HasSpell( AngrimSuccubusCurse ) )
		PlayerRef.AddSpell( AngrimSuccubusCurse, false )
		;; Start off with a 24 hour grace period before the magical decline sets in:
		AngrimSatiation.Value = 34
		StorageUtil.SetIntValue( PlayerRef, "Angrim_iSuccubusCurse", 1 )
	endIf
endFunction

Function MakeGhost()
	Actor corpse
	VC01BlackoutIMod.applyCrossFade(2.0)
	Wait( 3.0 )
	Game.ForceThirdPerson()

	;; Create a nude copy of the player character.  Equipment is not copied.
	;; The other main alternative here would be to create a TreasBurntCorpse03.
	;; Use KillEssential in the hope that this will work in spite of 'no death' mods.  Maybe.
	corpse = PlayerRef.PlaceActorAtMe( PlayerRef.GetActorBase() ) as actor
	corpse.UnequipAll()
	corpse.KillEssential( AngrimRef )

	PlayerRef.MoveTo( CenterPoint )
	PlayerRef.AddSpell( AngrimGhostlyStateSpell, false )
	PlayerRef.AddSpell( AngrimGhostFadeSpell, false )

	AngrimRef.Say( AngrimApprenticeMonologueGhost )
	Wait( 7.0 )
	imageSpaceModifier.removeCrossFade()
endFunction

Function GetAggressive()
	(self as Quest).SetStage( 100 )
	AngrimRef.StartCombat( PlayerRef )
endFunction

Function GiveGold( Int aiCount )
	PlayerRef.AddItem( Gold, aiCount )
endFunction

Function CheckThrallFade( Actor akActor )
	;; Chance that the Enthrall effect will wear off:
	if ( akActor != AngrimRef )
		if ( RandomInt() < 25 )
			akActor.RemoveFromFaction( AngrimEnthralledFaction )
			StorageUtil.SetIntValue( akActor, "Angrim_iEnthralled", 0 )
		endIf
	endIf
endFunction

Function GiveGear()
	BeltQuest.GiveBelt()
	Wait( 3.0 )
	PlayerRef.AddSpell( AngrimStealMagicSpell, true )
	AngrimSpellsTaught.Value = AngrimSpellsTaught.Value + 1
endFunction

Function GivePlugs()
	BeltQuest.GivePlugs()
endFunction

Function RemovePlugs()
	BeltQuest.TakePlugs()
endFunction

Function GiveBinder()
	BeltQuest.BinderLock()
endFunction

Function GivePotion()
	PlayerRef.RemoveItem( LoveElixirAliasRef.GetReference(), 1 )
	PlayerRef.AddItem( Reward, 1 )
	AngrimPlayerGotElixir.Value = 1
endFunction

Function SendForBook()
	AngrimBookQuest4.Start()
	AngrimBookQuest4.SetStage( 10 )
endFunction

Function GiveBook()
	PlayerRef.RemoveItem( AngrimBookTheRealms, 1 )
	PlayerRef.AddItem( Reward, 1 )
	;; Push the quest along, no sense waiting around.
	if ( AngrimSatiation.Value > 5 && AngrimSatiation.Value < 24 )
		AngrimSatiation.Value = 5
	endIf
endFunction

Function GetEmissary()
	;; This should be redundant - unless the character is in fact a Succubus
	AngrimHasCurse.Value = 0

	;; Summon Sanguine's Emissary to consumate the sacrifice.
	VC01BlackoutIMod.applyCrossFade(2.0)
	Wait( 2.0 )
	PlayerRef.MoveTo( CenterPoint )
	PlayerRef.PlayIdle( Bound )
	Wait( 6.0 )
	imageSpaceModifier.removeCrossFade()

	Wait( 8.0 )
	AngrimRef.Say( AngrimSummonMonologueTopic )

	Wait( 8.0 )
	AngrimSummonedEmissary.Value = 1
	AngrimSummonEmissarySpell.Cast( AngrimRef, PlayerRef )
endFunction

Function TriggerSnare()
	;; Turn the tables on Angrim with a secret spell (and Dibella's aid).
	VC01BlackoutIMod.applyCrossFade(2.0)
	Wait( 2.0 )
	PlayerRef.MoveTo( CenterPoint )
	RemoveBindings()
	Wait( 6.0 )
	imageSpaceModifier.removeCrossFade()

	Wait( 2.0 )
	PlayerRef.AddSpell( AngrimStealPowerSpell, false )
	PlayerRef.SetRelationshipRank( AngrimRef, 4 )
	BeltQuest.GiveKey()
endFunction

Event TriggerSoulSteal(string eventName, string argString, float argNum, form sender)
	;; Turn the tables on Angrim with a deadly carnal spell
	Wait( 2.0 )
	AngrimRef.Say( AngrimSoulStealTopic )
	Wait( 4.0 )
	if ( AngrimHasCurse.Value > 0 || DA14.GetStage() >= 200 )
		;; Otherwise, the spell won't be powerful enough to kill him.
		AngrimRef.KillEssential( PlayerRef )
		Wait( 10.0 )
		RemoveBindings()
	else
		;; He survived the spell, and will no longer consent to teach you:
		(self as Quest).SetStage( 100 )
	endIf
	UnregisterForModEvent( "AnimationEnd" )
endEvent

Event TriggerReturnToIdle(string eventName, string argString, float argNum, form sender)
	;; Return to the bound idle, since the cuffs don't seem to do it for us:
	If ( AngrimHasCuffs.Value > 0 )
		PlayerRef.PlayIdle( HandsBound )
	endIf
endEvent
