Scriptname angrimSuccubusScript extends activemagiceffect  

import Utility

SexLabFramework Property SexLab Auto

Actor Property PlayerRef Auto
GlobalVariable Property AngrimSatiation Auto
GlobalVariable Property AngrimHasCurse Auto
GlobalVariable Property AngrimPlayerIsSuccubus Auto
GlobalVariable Property AngrimPlayerIsBerserker Auto
GlobalVariable Property AngrimAggressiveCount Auto
Keyword Property AngrimBeltWorn Auto
Keyword Property Zad_DeviousBelt Auto
Keyword Property Zad_DeviousPlug Auto
Keyword Property AngrimSuccubusSoulTrap Auto
MagicEffect Property Zad_effEdgeOnly Auto
MagicEffect Property Zad_effEdgeRandom Auto
Float Property UpdateInterval Auto
Spell Property AngrimSuccubusFeedingSpell Auto
Spell Property AngrimFortifyMagicSpell Auto
Spell Property AngrimBerserkSpell Auto
ImageSpaceModifier Property VampireTransformIncreaseISMD Auto

Float MagickaDrain = 0.0
Bool  ShowOnce = true

Function DoMaintenance()
	Debug.Trace( "[Angrim] Registering mod events for Succubus Curse." )
	RegisterForModEvent( "AnimationEnd", "ResetSatiation" )
	RegisterForModEvent( "DeviceVibrateEffectStop", "LowerSatiation" )
	RegisterForSingleUpdateGametime( UpdateInterval )
	UnregisterForSleep()
	RegisterForSleep()
endFunction

Event OnPlayerLoadGame()
	if ( AngrimHasCurse.Value > 0 )
		DoMaintenance()
	endIf
endEvent

Event onEffectStart(Actor akTarget, Actor akCaster)
	AngrimHasCurse.Value = 1
	DoMaintenance()
EndEvent

Event onEffectFinish(Actor akTarget, Actor akCaster)
	;; Restore magicka to base value:
	if ( MagickaDrain > 0.0 )
		PlayerRef.modActorValue( "Magicka", MagickaDrain )
		MagickaDrain = 0.0
	endIf
EndEvent

Event ResetSatiation(string eventName, string argString, float argNum, form sender)
	sslThreadController controller = SexLab.HookController(argString)
	sslBaseAnimation anim = SexLab.HookAnimation(argString)
	Actor[] actorList = SexLab.HookActors(argString)
	int playerPos = controller.GetPlayerPosition()
	int satiation = AngrimSatiation.Value as int
	int desperation = 0
	int delta = 0
	int i
	bool bAggressive = false
	bool hasBelt = PlayerRef.wornHasKeyword(Zad_DeviousBelt)

	;; Ignore solo acts:
	if ( anim.HasTag( "Solo" ) )
		return
	endIf

	;; If playerPos is not negative, the player is involved in this animation.
	if ( playerPos >= 0 )
		;; If magical decline is in progress, reset it:
		if ( satiation < 10 )
			desperation = 10 - satiation
			satiation = 10
		endIf
		if ( MagickaDrain > 0.0 )
			PlayerRef.modActorValue("magicka", MagickaDrain)
			MagickaDrain = 0.0
		endIf

		;; Apply other feeding effects, for true Succubi:
		if ( AngrimPlayerIsSuccubus.Value != 0 )
			AngrimSuccubusFeedingSpell .Cast( PlayerRef, PlayerRef )
			if ( anim.HasTag( "Vaginal" ) && hasBelt == False )
				if ( PlayerRef.HasMagicEffectWithKeyword( AngrimSuccubusSoulTrap ) == False )
					;; Do not allow Drink Soul and the native Succubus power at the same time.
					;; Other similar spells, such as Drink Vital Essence, are permitted.
					PlayerRef.doCombatSpellApply( AngrimFortifyMagicSpell, PlayerRef )
				endIf
			endIf
		endIf

		;; Postpone magical decline by 0-24 hours:
		if ( anim.HasTag( "Oral" ) )
			delta += 2
		endIf
		if ( anim.HasTag( "Anal" ) )
			delta += 4
		endIf
		if ( anim.HasTag( "Spanking" ) )
			delta += 8
		endIf
		if ( anim.HasTag( "Fisting" ) )
			delta += 8
		endIf
		if ( anim.HasTag( "Orgy" ) )
			delta += 8
		endIf
		if ( anim.HasTag( "Vaginal" ) && hasBelt == False )
			delta += 16
		endIf
		if ( anim.HasTag( "Aggressive" ) || anim.HasTag( "Rough" ) || anim.HasTag( "forced" ) )
			delta = delta + (delta / 2) 
			bAggressive = true
			AngrimAggressiveCount.Value = AngrimAggressiveCount.Value + 1
		endIf

		;; Berserkers gain extra an extra abillity, but get less benefit from non-aggressive encounters:
		if ( AngrimPlayerIsBerserker.Value > 0 )
			if ( bAggressive )
				PlayerRef.AddSpell( AngrimBerserkSpell, true )
			else
				delta = delta / 2
			endIf
		endIf
		satiation = satiation + delta

		;; Notifications:
		if ( hasBelt )
			Debug.Notification( "The belt prevents you from gaining satisfaction..." )
		elseIf ( ! bAggressive && satiation < 18 )
			Debug.Notification( "That was somehow unsatisfying. You need something more..." )
		elseIf ( ! bAggressive && RandomInt(0,9) <= 4 )
			Debug.Notification( "Your lust is satisfied... for now" )
		endIf

		;; Cannot go more than 72 hours, regardless:
		if ( satiation > 72 )
			satiation = 72
		endIf
	endIf

	AngrimSatiation.Value = satiation
EndEvent

Event LowerSatiation(string eventName, string argString, float argNum, form sender)
	int satiation = AngrimSatiation.Value as int
	if ( argString != PlayerRef.GetLeveledActorBase().GetName() )
		return
	endIf
	if ( satiation > 5 )
		;; Each vibration event reduces satiation further:
		satiation = satiation - 2
		AngrimSatiation.Value = satiation
	endIf
EndEvent

Event OnUpdateGameTime()
	int satiation = AngrimSatiation.Value as int
	float magick
	float magick_delta
	bool not_busy = SexLab.IsValidActor( PlayerRef )

	satiation = satiation - 1
	if ( satiation < 0 )
		satiation = 0
	endIf
	
	if ( satiation < 10 )
		;; Subtract 10-100% from base magicka.  Note that base magicka may change
		;; between updates, so this script must track how much magicka drain has
		;; already been applied.
		magick = PlayerRef.GetBaseActorValue("magicka")
		magick = magick * (10 - satiation)/10.0
		if ( magick > MagickaDrain )
			magick_delta = magick - MagickaDrain
			MagickaDrain = magick
			PlayerRef.ModActorValue("magicka", -magick_delta)
		endIf
		;; Give the player a visual cue that this is happening:
		if ( not_busy )
			VampireTransformIncreaseISMD.applyCrossFade(2.0)
			utility.wait(2.0)
			imageSpaceModifier.removeCrossFade()
		endIf
	endIf

	if ( not_busy )
		if ( satiation < 3 )
			Debug.Notification( "You are in desperate need of release" )
		elseIf ( satiation < 10 && RandomInt() <= 40 )
			Debug.Notification( "Your lust is making it difficult to concentrate" )
		elseIf ( satiation < 20 && ShowOnce )
			Debug.Notification( "You feel unusually horny" )
			ShowOnce = false
		elseIf ( satiation < 20 && RandomInt() <= 25 )
			Debug.Notification( "Your lust is becoming hard to ignore" )
		endIf
	endIf
	
	AngrimSatiation.Value = satiation
	RegisterForSingleUpdateGameTime( UpdateInterval )
EndEvent

Event OnSleepStop(bool abInterrupted)
	if ( UpdateInterval < 2.0 && RandomInt() < 25 )
		;; Sanguine's Emissary has been playing with you again...
		SexLab.ApplyCum( PlayerRef, 7 )
		Wait( 5.0 )
		if ( abInterrupted )
			Debug.Notification( "Something woke you..." )
		endIf
		Debug.Notification( "You seem to be covered in something sticky..." )
	endIf
endEvent
